/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This file was generated.
 *  with google-apis-code-generator 1.3.0 (build: 2013-03-20 15:12:36 UTC)
 *  on 2013-03-21 at 23:43:09 UTC 
 */

package com.google.api.services.adexchangebuyer;

import com.google.api.client.googleapis.GoogleUtils;
import com.google.api.client.googleapis.services.AbstractGoogleClientRequest;
import com.google.api.client.googleapis.services.GoogleClientRequestInitializer;
import com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient;
import com.google.api.client.http.HttpRequestInitializer;
import com.google.api.client.http.HttpTransport;
import com.google.api.client.json.JsonFactory;
import com.google.api.client.json.JsonObjectParser;
import com.google.api.client.json.JsonString;
import com.google.common.base.Preconditions;

/**
 * Service definition for Adexchangebuyer (v1.2).
 *
 * <p>
 * Lets you manage your Ad Exchange Buyer account.
 * </p>
 *
 * <p>
 * For more information about this service, see the
 * <a href="https://developers.google.com/ad-exchange/buyer-rest" target="_blank">API Documentation</a>
 * </p>
 *
 * <p>
 * This service uses {@link AdexchangebuyerRequestInitializer} to initialize global parameters via its
 * {@link Builder}.
 * </p>
 *
 * <p>
 * Upgrade warning: this class now extends {@link AbstractGoogleJsonClient}, whereas in prior
 * version 1.8 it extended {@link com.google.api.client.googleapis.services.GoogleClient}.
 * </p>
 *
 * @since 1.3
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public class Adexchangebuyer extends AbstractGoogleJsonClient {

  // Note: Leave this static initializer at the top of the file.
  static {
    Preconditions.checkState(GoogleUtils.VERSION.equals("1.13.2-beta"),
        "You are currently running with version %s of google-api-client. " +
        "You need version 1.13.2-beta of google-api-client to run version " +
        "1.13.2-beta of the Ad Exchange Buyer API library.", GoogleUtils.VERSION);
  }

  /**
   * The default encoded root URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_ROOT_URL = "https://www.googleapis.com/";

  /**
   * The default encoded service path of the service. This is determined when the library is
   * generated and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_SERVICE_PATH = "adexchangebuyer/v1.2/";

  /**
   * The default encoded base URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   * @deprecated (scheduled to be removed in 1.13)
   */
  @Deprecated
  public static final String DEFAULT_BASE_URL = DEFAULT_ROOT_URL + DEFAULT_SERVICE_PATH;

  /**
   * Constructor.
   *
   * <p>
   * Use {@link Builder} if you need to specify any of the optional parameters.
   * </p>
   *
   * @param transport HTTP transport
   * @param jsonFactory JSON factory
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @since 1.7
   */
  public Adexchangebuyer(HttpTransport transport, JsonFactory jsonFactory,
      HttpRequestInitializer httpRequestInitializer) {
    super(transport,
        jsonFactory,
        DEFAULT_ROOT_URL,
        DEFAULT_SERVICE_PATH,
        httpRequestInitializer,
        false);
  }

  /**
   * @param transport HTTP transport
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @param rootUrl root URL of the service
   * @param servicePath service path
   * @param jsonObjectParser JSON object parser
   * @param googleClientRequestInitializer Google request initializer or {@code null} for none
   * @param applicationName application name to be sent in the User-Agent header of requests or
   *        {@code null} for none
   * @param suppressPatternChecks whether discovery pattern checks should be suppressed on required
   *        parameters
   */
  Adexchangebuyer(HttpTransport transport,
      HttpRequestInitializer httpRequestInitializer,
      String rootUrl,
      String servicePath,
      JsonObjectParser jsonObjectParser,
      GoogleClientRequestInitializer googleClientRequestInitializer,
      String applicationName,
      boolean suppressPatternChecks) {
    super(transport,
        httpRequestInitializer,
        rootUrl,
        servicePath,
        jsonObjectParser,
        googleClientRequestInitializer,
        applicationName,
        suppressPatternChecks);
  }

  @Override
  protected void initialize(AbstractGoogleClientRequest<?> httpClientRequest) throws java.io.IOException {
    super.initialize(httpClientRequest);
  }

  /**
   * An accessor for creating requests from the Accounts collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Adexchangebuyer adexchangebuyer = new Adexchangebuyer(...);}
   *   {@code Adexchangebuyer.Accounts.List request = adexchangebuyer.accounts().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Accounts accounts() {
    return new Accounts();
  }

  /**
   * The "accounts" collection of methods.
   */
  public class Accounts {

    /**
     * Gets one account by ID.
     *
     * Create a request for the method "accounts.get".
     *
     * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
     * optional parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param id The account id
     * @return the request
     */
    public Get get(Integer id) throws java.io.IOException {
      Get result = new Get(id);
      initialize(result);
      return result;
    }

    public class Get extends AdexchangebuyerRequest<com.google.api.services.adexchangebuyer.model.Account> {

      private static final String REST_PATH = "accounts/{id}";

      /**
       * Gets one account by ID.
       *
       * Create a request for the method "accounts.get".
       *
       * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
       * optional parameters, call the {@link Get#execute()} method to invoke the remote operation. <p>
       * {@link Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param id The account id
       * @since 1.13
       */
      protected Get(Integer id) {
        super(Adexchangebuyer.this, "GET", REST_PATH, null, com.google.api.services.adexchangebuyer.model.Account.class);
        this.id = Preconditions.checkNotNull(id, "Required parameter id must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The account id */
      @com.google.api.client.util.Key
      private Integer id;

      /** The account id
       */
      public Integer getId() {
        return id;
      }

      /** The account id */
      public Get setId(Integer id) {
        this.id = id;
        return this;
      }

    }
    /**
     * Retrieves the authenticated user's list of accounts.
     *
     * Create a request for the method "accounts.list".
     *
     * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
     * optional parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @return the request
     */
    public List list() throws java.io.IOException {
      List result = new List();
      initialize(result);
      return result;
    }

    public class List extends AdexchangebuyerRequest<com.google.api.services.adexchangebuyer.model.AccountsList> {

      private static final String REST_PATH = "accounts";

      /**
       * Retrieves the authenticated user's list of accounts.
       *
       * Create a request for the method "accounts.list".
       *
       * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
       * optional parameters, call the {@link List#execute()} method to invoke the remote operation. <p>
       * {@link List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @since 1.13
       */
      protected List() {
        super(Adexchangebuyer.this, "GET", REST_PATH, null, com.google.api.services.adexchangebuyer.model.AccountsList.class);
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

    }
    /**
     * Updates an existing account. This method supports patch semantics.
     *
     * Create a request for the method "accounts.patch".
     *
     * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
     * optional parameters, call the {@link Patch#execute()} method to invoke the remote operation.
     *
     * @param id The account id
     * @param content the {@link com.google.api.services.adexchangebuyer.model.Account}
     * @return the request
     */
    public Patch patch(Integer id, com.google.api.services.adexchangebuyer.model.Account content) throws java.io.IOException {
      Patch result = new Patch(id, content);
      initialize(result);
      return result;
    }

    public class Patch extends AdexchangebuyerRequest<com.google.api.services.adexchangebuyer.model.Account> {

      private static final String REST_PATH = "accounts/{id}";

      /**
       * Updates an existing account. This method supports patch semantics.
       *
       * Create a request for the method "accounts.patch".
       *
       * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
       * optional parameters, call the {@link Patch#execute()} method to invoke the remote operation.
       * <p> {@link Patch#initialize(AbstractGoogleClientRequest)} must be called to initialize this
       * instance immediately after invoking the constructor. </p>
       *
       * @param id The account id
       * @param content the {@link com.google.api.services.adexchangebuyer.model.Account}
       * @since 1.13
       */
      protected Patch(Integer id, com.google.api.services.adexchangebuyer.model.Account content) {
        super(Adexchangebuyer.this, "PATCH", REST_PATH, content, com.google.api.services.adexchangebuyer.model.Account.class);
        this.id = Preconditions.checkNotNull(id, "Required parameter id must be specified.");
      }

      @Override
      public Patch setAlt(String alt) {
        return (Patch) super.setAlt(alt);
      }

      @Override
      public Patch setFields(String fields) {
        return (Patch) super.setFields(fields);
      }

      @Override
      public Patch setKey(String key) {
        return (Patch) super.setKey(key);
      }

      @Override
      public Patch setOauthToken(String oauthToken) {
        return (Patch) super.setOauthToken(oauthToken);
      }

      @Override
      public Patch setPrettyPrint(Boolean prettyPrint) {
        return (Patch) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Patch setQuotaUser(String quotaUser) {
        return (Patch) super.setQuotaUser(quotaUser);
      }

      @Override
      public Patch setUserIp(String userIp) {
        return (Patch) super.setUserIp(userIp);
      }

      /** The account id */
      @com.google.api.client.util.Key
      private Integer id;

      /** The account id
       */
      public Integer getId() {
        return id;
      }

      /** The account id */
      public Patch setId(Integer id) {
        this.id = id;
        return this;
      }

    }
    /**
     * Updates an existing account.
     *
     * Create a request for the method "accounts.update".
     *
     * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
     * optional parameters, call the {@link Update#execute()} method to invoke the remote operation.
     *
     * @param id The account id
     * @param content the {@link com.google.api.services.adexchangebuyer.model.Account}
     * @return the request
     */
    public Update update(Integer id, com.google.api.services.adexchangebuyer.model.Account content) throws java.io.IOException {
      Update result = new Update(id, content);
      initialize(result);
      return result;
    }

    public class Update extends AdexchangebuyerRequest<com.google.api.services.adexchangebuyer.model.Account> {

      private static final String REST_PATH = "accounts/{id}";

      /**
       * Updates an existing account.
       *
       * Create a request for the method "accounts.update".
       *
       * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
       * optional parameters, call the {@link Update#execute()} method to invoke the remote operation.
       * <p> {@link Update#initialize(AbstractGoogleClientRequest)} must be called to initialize this
       * instance immediately after invoking the constructor. </p>
       *
       * @param id The account id
       * @param content the {@link com.google.api.services.adexchangebuyer.model.Account}
       * @since 1.13
       */
      protected Update(Integer id, com.google.api.services.adexchangebuyer.model.Account content) {
        super(Adexchangebuyer.this, "PUT", REST_PATH, content, com.google.api.services.adexchangebuyer.model.Account.class);
        this.id = Preconditions.checkNotNull(id, "Required parameter id must be specified.");
      }

      @Override
      public Update setAlt(String alt) {
        return (Update) super.setAlt(alt);
      }

      @Override
      public Update setFields(String fields) {
        return (Update) super.setFields(fields);
      }

      @Override
      public Update setKey(String key) {
        return (Update) super.setKey(key);
      }

      @Override
      public Update setOauthToken(String oauthToken) {
        return (Update) super.setOauthToken(oauthToken);
      }

      @Override
      public Update setPrettyPrint(Boolean prettyPrint) {
        return (Update) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Update setQuotaUser(String quotaUser) {
        return (Update) super.setQuotaUser(quotaUser);
      }

      @Override
      public Update setUserIp(String userIp) {
        return (Update) super.setUserIp(userIp);
      }

      /** The account id */
      @com.google.api.client.util.Key
      private Integer id;

      /** The account id
       */
      public Integer getId() {
        return id;
      }

      /** The account id */
      public Update setId(Integer id) {
        this.id = id;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Creatives collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Adexchangebuyer adexchangebuyer = new Adexchangebuyer(...);}
   *   {@code Adexchangebuyer.Creatives.List request = adexchangebuyer.creatives().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Creatives creatives() {
    return new Creatives();
  }

  /**
   * The "creatives" collection of methods.
   */
  public class Creatives {

    /**
     * Gets the status for a single creative.
     *
     * Create a request for the method "creatives.get".
     *
     * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
     * optional parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param accountId The id for the account that will serve this creative.
     * @param buyerCreativeId The buyer-specific id for this creative.
     * @return the request
     */
    public Get get(Integer accountId, String buyerCreativeId) throws java.io.IOException {
      Get result = new Get(accountId, buyerCreativeId);
      initialize(result);
      return result;
    }

    public class Get extends AdexchangebuyerRequest<com.google.api.services.adexchangebuyer.model.Creative> {

      private static final String REST_PATH = "creatives/{accountId}/{buyerCreativeId}";

      /**
       * Gets the status for a single creative.
       *
       * Create a request for the method "creatives.get".
       *
       * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
       * optional parameters, call the {@link Get#execute()} method to invoke the remote operation. <p>
       * {@link Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param accountId The id for the account that will serve this creative.
       * @param buyerCreativeId The buyer-specific id for this creative.
       * @since 1.13
       */
      protected Get(Integer accountId, String buyerCreativeId) {
        super(Adexchangebuyer.this, "GET", REST_PATH, null, com.google.api.services.adexchangebuyer.model.Creative.class);
        this.accountId = Preconditions.checkNotNull(accountId, "Required parameter accountId must be specified.");
        this.buyerCreativeId = Preconditions.checkNotNull(buyerCreativeId, "Required parameter buyerCreativeId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The id for the account that will serve this creative. */
      @com.google.api.client.util.Key
      private Integer accountId;

      /** The id for the account that will serve this creative.
       */
      public Integer getAccountId() {
        return accountId;
      }

      /** The id for the account that will serve this creative. */
      public Get setAccountId(Integer accountId) {
        this.accountId = accountId;
        return this;
      }

      /** The buyer-specific id for this creative. */
      @com.google.api.client.util.Key
      private String buyerCreativeId;

      /** The buyer-specific id for this creative.
       */
      public String getBuyerCreativeId() {
        return buyerCreativeId;
      }

      /** The buyer-specific id for this creative. */
      public Get setBuyerCreativeId(String buyerCreativeId) {
        this.buyerCreativeId = buyerCreativeId;
        return this;
      }

    }
    /**
     * Submit a new creative.
     *
     * Create a request for the method "creatives.insert".
     *
     * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
     * optional parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param content the {@link com.google.api.services.adexchangebuyer.model.Creative}
     * @return the request
     */
    public Insert insert(com.google.api.services.adexchangebuyer.model.Creative content) throws java.io.IOException {
      Insert result = new Insert(content);
      initialize(result);
      return result;
    }

    public class Insert extends AdexchangebuyerRequest<com.google.api.services.adexchangebuyer.model.Creative> {

      private static final String REST_PATH = "creatives";

      /**
       * Submit a new creative.
       *
       * Create a request for the method "creatives.insert".
       *
       * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
       * optional parameters, call the {@link Insert#execute()} method to invoke the remote operation.
       * <p> {@link Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this
       * instance immediately after invoking the constructor. </p>
       *
       * @param content the {@link com.google.api.services.adexchangebuyer.model.Creative}
       * @since 1.13
       */
      protected Insert(com.google.api.services.adexchangebuyer.model.Creative content) {
        super(Adexchangebuyer.this, "POST", REST_PATH, content, com.google.api.services.adexchangebuyer.model.Creative.class);
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

    }
    /**
     * Retrieves a list of the authenticated user's active creatives.
     *
     * Create a request for the method "creatives.list".
     *
     * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
     * optional parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @return the request
     */
    public List list() throws java.io.IOException {
      List result = new List();
      initialize(result);
      return result;
    }

    public class List extends AdexchangebuyerRequest<com.google.api.services.adexchangebuyer.model.CreativesList> {

      private static final String REST_PATH = "creatives";

      /**
       * Retrieves a list of the authenticated user's active creatives.
       *
       * Create a request for the method "creatives.list".
       *
       * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
       * optional parameters, call the {@link List#execute()} method to invoke the remote operation. <p>
       * {@link List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @since 1.13
       */
      protected List() {
        super(Adexchangebuyer.this, "GET", REST_PATH, null, com.google.api.services.adexchangebuyer.model.CreativesList.class);
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** When specified, only creatives having the given status are returned. */
      @com.google.api.client.util.Key
      private String statusFilter;

      /** When specified, only creatives having the given status are returned.
       */
      public String getStatusFilter() {
        return statusFilter;
      }

      /** When specified, only creatives having the given status are returned. */
      public List setStatusFilter(String statusFilter) {
        this.statusFilter = statusFilter;
        return this;
      }

      /**
     * A continuation token, used to page through ad clients. To retrieve the next page, set this
     * parameter to the value of "nextPageToken" from the previous response. Optional.
     */
      @com.google.api.client.util.Key
      private String pageToken;

      /** A continuation token, used to page through ad clients. To retrieve the next page, set this
     parameter to the value of "nextPageToken" from the previous response. Optional.
       */
      public String getPageToken() {
        return pageToken;
      }

      /**
     * A continuation token, used to page through ad clients. To retrieve the next page, set this
     * parameter to the value of "nextPageToken" from the previous response. Optional.
     */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /**
     * Maximum number of entries returned on one result page. If not set, the default is 100.
     * Optional.
     */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** Maximum number of entries returned on one result page. If not set, the default is 100. Optional.

     [minimum: 1] [maximum: 1000]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /**
     * Maximum number of entries returned on one result page. If not set, the default is 100.
     * Optional.
     */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the DirectDeals collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Adexchangebuyer adexchangebuyer = new Adexchangebuyer(...);}
   *   {@code Adexchangebuyer.DirectDeals.List request = adexchangebuyer.directDeals().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public DirectDeals directDeals() {
    return new DirectDeals();
  }

  /**
   * The "directDeals" collection of methods.
   */
  public class DirectDeals {

    /**
     * Gets one direct deal by ID.
     *
     * Create a request for the method "directDeals.get".
     *
     * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
     * optional parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param id The direct deal id
     * @return the request
     */
    public Get get(Long id) throws java.io.IOException {
      Get result = new Get(id);
      initialize(result);
      return result;
    }

    public class Get extends AdexchangebuyerRequest<com.google.api.services.adexchangebuyer.model.DirectDeal> {

      private static final String REST_PATH = "directdeals/{id}";

      /**
       * Gets one direct deal by ID.
       *
       * Create a request for the method "directDeals.get".
       *
       * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
       * optional parameters, call the {@link Get#execute()} method to invoke the remote operation. <p>
       * {@link Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param id The direct deal id
       * @since 1.13
       */
      protected Get(Long id) {
        super(Adexchangebuyer.this, "GET", REST_PATH, null, com.google.api.services.adexchangebuyer.model.DirectDeal.class);
        this.id = Preconditions.checkNotNull(id, "Required parameter id must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The direct deal id */
      @com.google.api.client.util.Key
      private Long id;

      /** The direct deal id
       */
      public Long getId() {
        return id;
      }

      /** The direct deal id */
      public Get setId(Long id) {
        this.id = id;
        return this;
      }

    }
    /**
     * Retrieves the authenticated user's list of direct deals.
     *
     * Create a request for the method "directDeals.list".
     *
     * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
     * optional parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @return the request
     */
    public List list() throws java.io.IOException {
      List result = new List();
      initialize(result);
      return result;
    }

    public class List extends AdexchangebuyerRequest<com.google.api.services.adexchangebuyer.model.DirectDealsList> {

      private static final String REST_PATH = "directdeals";

      /**
       * Retrieves the authenticated user's list of direct deals.
       *
       * Create a request for the method "directDeals.list".
       *
       * This request holds the parameters needed by the the adexchangebuyer server.  After setting any
       * optional parameters, call the {@link List#execute()} method to invoke the remote operation. <p>
       * {@link List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @since 1.13
       */
      protected List() {
        super(Adexchangebuyer.this, "GET", REST_PATH, null, com.google.api.services.adexchangebuyer.model.DirectDealsList.class);
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

    }

  }

  /**
   * Builder for {@link Adexchangebuyer}.
   *
   * <p>
   * Implementation is not thread-safe.
   * </p>
   *
   * @since 1.3.0
   */
  public static final class Builder extends AbstractGoogleJsonClient.Builder {

    /**
     * Returns an instance of a new builder.
     *
     * @param transport HTTP transport
     * @param jsonFactory JSON factory
     * @param httpRequestInitializer HTTP request initializer or {@code null} for none
     * @since 1.7
     */
    public Builder(HttpTransport transport, JsonFactory jsonFactory,
        HttpRequestInitializer httpRequestInitializer) {
      super(
          transport,
          jsonFactory,
          DEFAULT_ROOT_URL,
          DEFAULT_SERVICE_PATH,
          httpRequestInitializer,
          false);
    }

    /** Builds a new instance of {@link Adexchangebuyer}. */
    @Override
    public Adexchangebuyer build() {
      return new Adexchangebuyer(getTransport(),
          getHttpRequestInitializer(),
          getRootUrl(),
          getServicePath(),
          getObjectParser(),
          getGoogleClientRequestInitializer(),
          getApplicationName(),
          getSuppressPatternChecks());
    }

    @Override
    public Builder setRootUrl(String rootUrl) {
      return (Builder) super.setRootUrl(rootUrl);
    }

    @Override
    public Builder setServicePath(String servicePath) {
      return (Builder) super.setServicePath(servicePath);
    }

    @Override
    public Builder setHttpRequestInitializer(HttpRequestInitializer httpRequestInitializer) {
      return (Builder) super.setHttpRequestInitializer(httpRequestInitializer);
    }

    @Override
    public Builder setApplicationName(String applicationName) {
      return (Builder) super.setApplicationName(applicationName);
    }

    @Override
    public Builder setSuppressPatternChecks(boolean suppressPatternChecks) {
      return (Builder) super.setSuppressPatternChecks(suppressPatternChecks);
    }

    /**
     * Set the {@link AdexchangebuyerRequestInitializer}.
     *
     * @since 1.12
     */
    public Builder setAdexchangebuyerRequestInitializer(
        AdexchangebuyerRequestInitializer adexchangebuyerRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(adexchangebuyerRequestInitializer);
    }

    @Override
    public Builder setGoogleClientRequestInitializer(
        GoogleClientRequestInitializer googleClientRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(googleClientRequestInitializer);
    }
  }
}
